#include <bits/stdc++.h>

using namespace std;

#define ll long long

const ll INF = 1e18;
const int maxN = 100005;

struct Query {
    int t;
    int h;
    int i;
};

bool operator < (Query q1, Query q2) {
    return q1.h < q2.h || (q1.h == q2.h && q1.i < q2.i);
}

map<int, vector<int>> ind;

Query arr[maxN];
Query brr[maxN];
bool used[maxN];

int ans[maxN];

int solve(int t, int& lst, int n) {
    while (lst < n) {
        if (!used[lst]) return lst;
        lst++;
    }
    return -1;
}

int main() {
    //freopen("in.in", "r", stdin);

    int n, m;
    cin >> n >> m;

    for (int i = 0; i < n; i++) {
        int t, h;
        cin >> t >> h;
        arr[i].t = t;
        arr[i].h = h;
        arr[i].i = i;
        brr[i] = arr[i];
    }

    for (int i = 0; i < n; i++) ans[i] = -1;

    sort(brr, brr + n, [](Query q1, Query q2) {return q1.t + q1.h < q2.t + q2.h; });

    int lst = 0;
    int t = 0;

    int i = 0;
    int brr_i = 0;

    set<Query> cur;
    while (lst < n) {
        int j = solve(t, lst, n);
        t = max(t, arr[j].t);
        int nt = t + arr[j].h - 1;

        //cout << lst << " " << t << " " << nt << " " << j << " " << arr[j].h << " " << i << " " << brr_i << endl;

        if (j == -1) break;



        while (i < n && arr[i].t <= nt) {
            cur.insert(arr[i]);
            ind[arr[i].h].push_back(i);
            i++;
        }

        for (int k : ind[arr[j].h]) {
            if(!used[k]) ans[k] = nt + arr[j].h - 1;
            used[k] = 1;
        }
        ind[arr[j].h].clear();

        int t0 = nt, h0 = arr[j].h;

        while (brr_i < n && brr[brr_i].h + brr[brr_i].t <= t0 + h0) {
            if (!used[brr_i]) cur.insert(brr[brr_i]);
            brr_i++;
        }

        while (cur.size() > 0 && cur.begin()->h <= h0) {
            Query q = *cur.begin(); cur.erase(cur.begin());

            if (!used[q.i]) ans[q.i] = t0 + arr[j].h - 1;
            used[q.i] = 1;
        }

        t = nt + arr[j].h - 1;
    }

    for (int i = 0; i < n; i++) cout << ans[i] << " ";
    cout << endl;

    return 0;
}
