#include <bits/stdc++.h>

using namespace std;

#define ll long long

const ll INF = 1e18;
const int maxN = 200005;
vector<int> ch[maxN];
ll hv[maxN];
ll mhv[maxN];
ll dp[maxN];

set<int> ss;
void dfs(int v) {

    ss.insert(v);
    mhv[v] = hv[v];
    dp[v] = 0;

    for (int u : ch[v]) {
        hv[u] = hv[v] + 1;
        dfs(u);
        mhv[v] = max(mhv[v], mhv[u]);
        dp[v] = max(dp[v], dp[u]);
    }

    if (ch[v].size() >= 2) {
        int i = 0;
        for (int k = 0; k < ch[v].size(); k++) {
            if (mhv[ch[v][k]] > mhv[ch[v][i]]) i = k;
        }
        int j = (i == 0 ? 1 : 0);
        for (int k = 0; k < ch[v].size(); k++) {
            if (k != i && mhv[ch[v][k]] > mhv[ch[v][j]]) j = k;
        }

        //cout << ch[v][i] + 1 << " " << ch[v][j] + 1 << endl;
        dp[v] = mhv[ch[v][i]] + mhv[ch[v][j]] - 2 * hv[v] + 1;
    }
}

int main() {
    //freopen("in.in", "r", stdin);

    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n, m;
    cin >> n >> m;

    assert(n <= 1000);

    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        p--;
        ch[p].push_back(i);
    }

    dfs(0);

    /*for (int i = 0; i < n; i++) {
        cout << dp[i] << " " << hv[i] << " " << mhv[i] << endl;
    }
    return 0;*/

    ll ans = 0;
    if (dp[0] > 0) {
        ans = dp[0] + 2 * ((mhv[0] + 1) * (m - 1));
    }
    ans = max(ans, (mhv[0] + 1) * m);

    cout << ans << endl;

    return 0;
}
