#include <bits/stdc++.h>

using namespace std;

#define ll long long

const ll INF = 1e18;
const int maxN = 200005;
vector<int> edge[maxN];
ll hv[maxN];
pair<ll, int> dp[maxN];

void dfs(int v, int p) {
    dp[v] = {hv[v], v};
    for (int u : edge[v]) {
        if (u == p) continue;
        hv[u] = hv[v] + 1;
        dfs(u, v);
        dp[v] = max(dp[v], dp[u]);
    }
}

int main() {
    //freopen("in.in", "r", stdin);

    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n, m;
    cin >> n >> m;

    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        p--;
        edge[p].push_back(i);
        edge[i].push_back(p);
    }

    ll ans = 0;
    for (int i = 0; i < n; i++) {
        hv[i] = 0;
        dfs(i, -1);
        ans = max(ans, dp[i].first + 1);
    }
    cout << ans << endl;

    return 0;
}
