#include <bits/stdc++.h>

using namespace std;

#define ll long long

const ll INF = 1e18;
const int maxN = 100005;

struct Seg {
    int l, r;
    int c;
};

vector<Seg> arr;

int solve(int l, int r, int c, int M, vector<Seg>& arr) {
    if (arr.size() == 1) {
        return arr[0].c != c;
    }
    int m = (l + r) / 2;

    vector<Seg> arr1, arr2;
    for (int i = 0; i < arr.size(); i++) {
        if (arr[i].l < m) arr1.push_back(arr[i]);
        if (arr[i].r > m) arr2.push_back(arr[i]);
    }

    int ans = solve(l, m, c, M, arr1) + solve(m, r, c, M, arr2);
    for (int nc = 1; nc <= M; nc++) {
        ans = min(ans, solve(l, m, nc, M, arr1) + solve(m, r, nc, M, arr2) + 1);
    }

    return ans;
}

int main() {
    //freopen("in.in", "r", stdin);

    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int k, n, m;
    cin >> k >> n >> m;

    int lst = 0;
    for (int i = 0; i < n; i++) {
        Seg seg;
        int len, c;
        cin >> len >> c;
        seg.l = lst;
        seg.r = lst + len;
        seg.c = c;
        arr.push_back(seg);

        lst += len;
    }

    cout << solve(0, 1<<k, 0, m, arr) << endl;

    return 0;
}
