#include <bits/stdc++.h>

using namespace std;

#define ll long long

const int INF = 1e9;
const int maxN = 100005;

struct Seg {
    int l, r;
    int c;
};

vector<Seg> arr;

int solve(int l, int r, vector<Seg>& arr, int c) {
    if (arr.size() == 1) {
        c = arr[0].c;
        return 0;
    }

    int m = (l + r) / 2;

    vector<Seg> arr1, arr2;
    for (int i = 0; i < arr.size(); i++) {
        if (arr[i].l < m) arr1.push_back(arr[i]);
        if (arr[i].r > m) arr2.push_back(arr[i]);
    }

    int cl, cr;
    int optl, optr;

    optl = solve(l, m, arr1, cl);
    optr = solve(m, r, arr2, cr);

    int opt = 0;
    if (cl == cr || cl == -1 || cr == -1) {
        opt = optl + optr;
        c = (cl == -1 ? cr : cl);
    }
    else {
        opt = optl + optr + 1;
        c = -1;
    }
    return opt;
}

int main() {
    //freopen("in.in", "r", stdin);

    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int k, n, m;
    cin >> k >> n >> m;

    int lst = 0;
    for (int i = 0; i < n; i++) {
        Seg seg;
        int len, c;
        cin >> len >> c;
        seg.l = lst;
        seg.r = lst + len;
        seg.c = c;
        arr.push_back(seg);

        lst += len;
    }

    int c;
    int ans = solve(0, (1<<k), arr, c);

    cout << (ans + (c != 0)) << endl;

    return 0;
}
