#include <bits/stdc++.h>

using namespace std;

#define ll long long

const ll INF = 1e17;
const ll maxY = 1000005;

ll solve(ll x) {
    ll l = 1, r = min(x + 1, 1000000239);
    while (r - l > 1) {
        ll m = (l + r) / 2;
        if (m * m > x) r = m;
        else l = m;
    }
    return l;
}

int main() {
    //freopen("in.in", "r", stdin);

    ll a, b, k;
    cin >> a >> b >> k;

    ll ans = 0;
    for (ll y = 1; y <= maxY; y++) {
        if (y * y * y < a || y * y * y > b) continue;

        ll l = max(a, y * y * y - k);
        ll r = min(b, y * y * y + k);

        ll sl = solve(l);
        if (sl * sl < l) sl++;
        ll sr = solve(r);

        if (sl > sr) continue;
        ans += sr - sl + 1;
    }

    cout << ans << endl;

    return 0;
}
