#include <bits/stdc++.h>

using namespace std;

#define ll long long

const ll INF = 1e18;
const int maxN = 505;
const int maxM = 100005;
const int ALPH = 26;
const int maxS = 1000005;

vector<pair<string, int>> arr;
int rind[maxM];
vector<ll> wrr;
vector<pair<int, char>> ch[maxN];

int go[maxS][26];
int suff[maxS];
int super_suff[maxS];
int hv[maxS];
bool term[maxS];
int ind[maxS];
ll cost[maxS];
int CNT = 0;

int newVert() {
    for (int c = 0; c < ALPH; c++) go[CNT][c] = -1;
    suff[CNT] = 0;
    super_suff[CNT] = -1;
    cost[CNT] = INF;
    return CNT++;
}

void add(string &s, ll w, int j) {
    int v = 0;
    for (int i = 0; i < s.size(); i++) {
        if (go[v][s[i]] == -1) {
            go[v][s[i]] = newVert();
            hv[go[v][s[i]]] = hv[v] + 1;
        }
        v = go[v][s[i]];
    }
    term[v] = 1;
    ind[v] = j;
    cost[v] = min(cost[v], w);
}

void build() {
    for (int c = 0; c < ALPH; c++) {
        if (go[0][c] == -1) go[0][c] = 0;
    }

    queue<int> q;
    for (int c = 0; c < ALPH; c++) {
        if (go[0][c] != 0) q.push(go[0][c]);
    }

    while (q.size() > 0) {
        int v = q.front(); q.pop();
        for (int c = 0; c < ALPH; c++) {
            if (go[v][c] != -1) q.push(go[v][c]);
        }

        for (int c = 0; c < ALPH; c++) {
            if (go[v][c] != -1) {
                suff[go[v][c]] = go[suff[v]][c];
                continue;
            }

            go[v][c] = go[suff[v]][c];
        }

        if (term[suff[v]]) super_suff[v] = suff[v];
        else super_suff[v] = super_suff[suff[v]];
    }
}

pair<ll, pair<int, int>> dp[maxN][maxN];

void dfs(int v, int cur) {
    for (int h = 0; h < maxN; h++) dp[v][h] = {INF, {-1, -1}};

    for (auto p : ch[v]) {
        dfs(p.first, go[cur][p.second]);
    }

    ll sum = 0;
    for (auto p : ch[v]) sum += dp[p.first][1].first;
    int lcur = cur;
    while (lcur != -1) {
        dp[v][hv[lcur]] = {sum + cost[lcur], {ind[lcur], -1}};
        lcur = super_suff[lcur];
    }
    dp[v][0] = {sum, {-1, -1}};

    for (int h = 0; h < maxN - 1; h++) {
        for (int i = 0; i < ch[v].size(); i++) {
            ll sum = 0;
            for (int j = 0; j < ch[v].size(); j++) {
                if (j != i) sum += dp[ch[v][j].first][1].first;
            }
            sum += dp[ch[v][i].first][h + 1].first;

            dp[v][h] = min(dp[v][h], {sum, {-1, i}});
        }
    }

    for (int h = maxN - 2; h >= 0; h--) {
        dp[v][h] = min(dp[v][h], dp[v][h + 1]);
    }
}

vector<int> st;
vector<vector<int>> ans;
void dfs2(int v, int h) {
    st.push_back(v);

    auto pr = dp[v][h].second;
    for (int i = 0; i < ch[v].size(); i++) {
        if (pr.second == i) dfs2(ch[v][i].first, h + 1);
        else dfs2(ch[v][i].first, 1);
    }

    if (pr.first != -1) {
        ans.push_back({st[st.size() - 1 - arr[rind[pr.first]].first.size()], v, pr.first});
    }

    st.pop_back();
}

int main() {
    //freopen("in.in", "r", stdin);

    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n, m, t;
    cin >> n >> m >> t;

    for (int i = 1; i < n; i++) {
        int p;
        char c;
        cin >> p >> c;
        p--;

        ch[p].push_back({i, c - 'a'});
    }

    for (int i = 0; i < m; i++) {
        string s;
        ll w;
        cin >> w >> s;

        if (s.size() <= n) {
            for (int k = 0; k < s.size(); k++) s[k] -= 'a';

            rind[i] = arr.size();
            arr.push_back({s, i});
            wrr.push_back(w);
        }
    }
    m = arr.size();

    newVert();
    for (int i = 0; i < m; i++) {
        add(arr[i].first, wrr[i], arr[i].second);
    }
    build();

    dfs(0, 0);
    if (dp[0][0].first == INF) cout << -1 << endl;
    else cout << dp[0][0].first << endl;

    if (dp[0][0].first != INF && t) {
        dfs2(0, 0);
        cout << ans.size() << endl;
        for (auto v : ans) {
            cout << v[0] + 1 << " " << v[1] + 1 << " " << v[2] + 1 << endl;
        }
    }


    return 0;
}
