#include <bits/stdc++.h>

using namespace std;

#define ll long long

const ll INF = 1e18;

ll sum(ll l, ll r) {
    return (2 * l * (r - l) + (r - l) * (r - l - 1)) / 2;
}

ll solve(ll k, ll s, ll cnt) {
    if (s < sum(k + 1, k + cnt + 1)) return INF;
    if (s == sum(k + 1, k + cnt + 1)) return k;

    ll l = 0, r = s / cnt + 3;
    while (r - l > 1) {
        ll m = (l + r) / 2;
        if (s > sum(k + m + 1, k + cnt + m + 1)) l = m;
        else r = m;
    }

    return k + r;
}

int main() {
    //freopen("in.in", "r", stdin);

    cin.tie(0);
    ios_base::sync_with_stdio(0);

    ll k, s;
    cin >> k >> s;

    ll cnt = 1;
    ll ans = INF;
    while (true) {
        ll lans = solve(k, s, cnt);
        if (lans == INF) break;
        ans = min(ans, lans);
        cnt++;
    }
    cout << ans << endl;

    return 0;
}
